

local IdToSlash = {
	[8] = "/blades",
	[10] = "/handsup",
	[12] = "/bag",
	[14] = "/map",
	[16] = "/bowltaste",
	[17] = "/fishing1",
	[18] = "/fishing2",
	[19] = "/fishing3",
	[89] = "/talk1",
	[90] = "/talk2",
	[91] = "/talk3",
	[92] = "/talk4",
	[93] = "/talk5",
	[110] = "/axeloop",
	[111] = "/axe2loop",
	[112] = "/pickaxeloop",
	[113] = "/pickaxe2loop",
	[114] = "/skinning",
	[115] = "/levitate",
	[117] = "/portalenter",
	[127] = "/blacksmith",
	[128] = "/alchemy",
	[129] = "/cooking",
	[130] = "/enchanting",
	[132] = "/swiftkick",
	[136] = "/woodworking",
	[137] = "/kneelbrushing",
	[138] = "/kneelpulling",
	--[187] = "/sleeprough",
	[188] = "/pickaxe2",
	[189] = "/pickaxe",
	[192] = "/sleeprough",
	--[194] = "/take",
	[195] = "/readshort",
	[196] = "/axeswing",
	[197] = "/picklock",
	[198] = "/shovelshort",
	--[199] = "/gatherkneel",
	[200] = "/steindrink",
	[201] = "/filldrink",
	--[207] = "/gatherkneel",
	[208] = "/bagempty",
	[209] = "/fluteshort",
	[210] = "/powersword", -- THUNDER THUNDER CATS HO!
	[211] = "/arghgrow",
	[212] = "/eatbreadslow",
	[213] = "/arghlong",
	[214] = "/hornalt",
	--[215] = "/blacksmith",
	[216] = "/levitatepower",
	[217] = "/stabdagger",
	--[218] = "/gatherkneel",
	--[219] = "/gatherkneel",
	[220] = "/gatherkneel",
	[221] = "/hammerswing",
	[223] = "/gathercrouched",
	[226] = "/readgreen",
	[227] = "/readscroll",
	[228] = "/readbrown",
	[229] = "/writeledger",
	[231] = "/frustrated",
	[234] = "/readclosed",
	[235] = "/woodsanding",
	--[236] = "STUB",
	[238] = "/drinkchalace",
	[239] = "/levitatespin",
	[242] = "/fallgetup",
	[243] = "/sit_rough",
	[244] = "/takewall",
	[245] = "/take",
	[246] = "/pickup",
	[247] = "/kneelpicklock",
	[248] = "/kneelcarve",
	[249] = "/eatsoup",
	[250] = "/argh",
	[251] = "/meat",
}


EmoteToy = {}


function EmoteToy:ListAll( text )
	local buffer = {}
	for i=1, GetNumEmotes() do
		local emote_name = GetEmoteSlashName( i )
		if IdToSlash[ i ] then
			emote_name = IdToSlash[ i ]
		elseif emote_name == "" and text == "unlisted" and not IdToSlash[ i ] then
			emote_name = "/e"..i
		end
		table.insert( buffer, emote_name )
	end
	
	EmoteToy:Print( table.concat( buffer, ",  ") )
end


function EmoteToy:Print( text )
	d( text )
end

function EmoteToy:PlayEmote( id )
	id = tonumber(id)
	--EmoteToy:Print( "Playing Emote Id: "..id.." Name: ".. ( IdToSlash[ id ] or GetEmoteSlashName( id ) ) )
	PlayEmote(id)
end


function LK_OnInit( self )
    SLASH_COMMANDS['/et_list'] = function( ... ) EmoteToy:ListAll( ... ) end
	for i=1, GetNumEmotes() do
		local emote_slash = "/e"..i
		AddEmote(emote_slash, i)
		if IdToSlash[ i ] then
			-- Also reg under unique name
			AddEmote(IdToSlash[ i ], i)
		end
	end
end

function AddEmote(slash, id)
	if not SLASH_COMMANDS[slash] then
		SLASH_COMMANDS[slash] = function() EmoteToy:PlayEmote( id ) end
	else
		EmoteToy:Print( "Slash Command: "..slash.." already exists!" )
	end
end